#!/usr/bin/python
#
# Flags full disks.
#
# @Copyright@
# 
# 				Rocks
# 		         www.rocksclusters.org
# 			     Version 3.2.0
# 
# Copyright (c) 2004 The Regents of the University of California. All
# rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# 3. All advertising materials mentioning features or use of this
# software must display the following acknowledgement: This product
# includes software developed by the ROCKS CLUSTER GROUP at the San
# Diego Supercomputer Center and its contributors.
# 
# 4. Neither the name of the Center nor the names of its contributors
# may be used to endorse or promote products derived from this software
# without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
# IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# @Copyright@
#
# $Log: full.py,v $
# Revision 1.2  2004/04/20 04:30:44  fds
# Not as stupid. Will give more than one news item if necessary.
#
# Revision 1.1  2004/04/14 22:01:49  fds
# Less verbose, quoting special chars in cluster name. New full-disk
# journalist inspired by lodestone.
#
#

import os
import sys
import gmon.journalist

class Full(gmon.journalist.Journalist):
	"""A news collector that detects full disk partitions."""

	fullthresh = 95.0

	def run(self):
	
		c = self.getGanglia().getCluster()
		for h in c.getHosts():
			try:
				f = float(h.getMetricValue('part_max_used'))
				if f > self.fullthresh:
					print self.item(c, h, f)
			except:
				continue


	def item(self, cluster, host, fullest):

		s = '  <item>\n' \
		  + '   <description>\n' \
		  + '%s. Node %s has a disk which is %d%% full. ' \
		  	% (self.getDate(), host.getName(), fullest) \
		  + '(Threshold is %d%%)\n' \
			% (self.fullthresh) \
		  + '   </description>\n' \
		  + '   <link>%s</link>\n' \
			% self.getHostPage(cluster, host) \
		  + '   <pubDate>%s</pubDate>\n' % self.getTime() \
		  + '  </item>\n'

		self.recordItem(host.getIP(), s)

		# Not necessary, useful for debugging.
		return s

		
		
def initEvents():
	return Full

