#!/usr/bin/python
#
# @Copyright@
# 
# 				Rocks
# 		         www.rocksclusters.org
# 			     Version 3.2.0
# 
# Copyright (c) 2004 The Regents of the University of California. All
# rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# 3. All advertising materials mentioning features or use of this
# software must display the following acknowledgement: This product
# includes software developed by the ROCKS CLUSTER GROUP at the San
# Diego Supercomputer Center and its contributors.
# 
# 4. Neither the name of the Center nor the names of its contributors
# may be used to endorse or promote products derived from this software
# without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
# IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# @Copyright@
#
# $Log: load.py,v $
# Revision 1.1  2004/04/13 20:16:05  fds
# The Ganglia RSS news prototype. 2 journalsits: MIA and load.
#
#

import os
import sys
import gmon.journalist

class Load(gmon.journalist.Journalist):
	"""A news collector that detects overloaded nodes."""

	# When 5min load exceeds this*CPUs, we call it news.
	loadthresh = 50.0
	
	def name(self):
		return "load"

	def run(self):
		s = ''
		c = self.getGanglia().getCluster()
		for h in c.getHosts():
			try:
				cpus = int(h.getMetricValue('cpu_num'))
				load5 = float(h.getMetricValue('load_five'))

				if load5 > self.loadthresh * cpus:
					s += self.item(c, h, load5, cpus)
			except:
				continue
				
		# Not necessary, useful for debugging.
		return s
		

	def item(self, cluster, host, load5, cpus):

		plural = ''
		if cpus > 1:
			plural = 's'

		s = '  <item>\n' \
		  + '   <description>\n' \
		  + '%s. Node %s is overloaded. ' \
		  	% (self.getDate(), host.getName()) \
		  + 'It has a 5min load of %s, with %s cpu%s.\n\n' \
			% (load5, cpus, plural) \
		  + '(Threshold is %s (%s*%s))\n' \
			% (self.loadthresh * cpus,
			self.loadthresh, cpus) \
		  + '   </description>\n' \
		  + '   <link>%s</link>\n' % self.getHostPage(cluster, host) \
		  + '   <pubDate>%s</pubDate>\n' % self.getTime() \
		  + '  </item>\n'

		self.recordItem(host.getIP(), s)
		return s

		
		
def initEvents():
	return Load

