#!/usr/bin/python
#
# The base classe for Ganglia news journalists.
#
# @Copyright@
# 
# 				Rocks
# 		         www.rocksclusters.org
# 			     Version 3.2.0
# 
# Copyright (c) 2004 The Regents of the University of California. All
# rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# 3. All advertising materials mentioning features or use of this
# software must display the following acknowledgement: This product
# includes software developed by the ROCKS CLUSTER GROUP at the San
# Diego Supercomputer Center and its contributors.
# 
# 4. Neither the name of the Center nor the names of its contributors
# may be used to endorse or promote products derived from this software
# without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
# IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# @Copyright@
#
# $Log: mia.py,v $
# Revision 1.1  2004/04/13 20:16:05  fds
# The Ganglia RSS news prototype. 2 journalsits: MIA and load.
#
#

import os
import sys
import gmon.journalist

class MIA(gmon.journalist.Journalist):
	"""A news collector that detects dead nodes."""
	
	# How many secs of silence before we consider a host dead.
	alivethresh = 18000
	
	def name(self):
		return "dead"

	def run(self):
		s = ''
		c = self.getGanglia().getCluster()
		for h in c.getHosts():
			tn = h.getTn()
			if int(tn) > self.alivethresh:
				s += self.item(c,h)
		return s
	
			
	def item(self, cluster, host):
		
		lastseen = self.uptime(host.getTn())

		s = '  <item>\n' \
		  + '   <description>\n' \
		  + '%s. Node %s found dead. ' % (self.getDate(),host.getName()) \
		  + 'Last reported %s ago.\n\n' % lastseen \
		  + '(Threshold is %s (hr:min:sec))\n' \
		  	% self.uptime(self.alivethresh) \
		  + '   </description>\n' \
		  + '   <link>%s</link>\n' % self.getHostPage(cluster, host) \
		  + '   <pubDate>%s</pubDate>\n' % self.getTime() \
		  + '  </item>\n'

		self.recordItem(host.getIP(), s)
		return s
		
		
def initEvents():
	return MIA
	
